<template>
  <div class="col-12">
    <h5 class="mb-5">List Starships</h5>
    <div class="col-xl-6 col-sm-auto mb-5">
      <b-input-group size="xl">
        <input class="form-control" v-model="keyword" placeholder="Search" type="text" style="color:#959595;">
      </b-input-group>
    </div>
    <div class="table-responsive col-xl-12 col-sm-5">
      <table class="table table-info">
        <thead>
          <tr class="font-weight-bold">
            <th scope="col" class="text-center bold"><b>No</b></th>
            <th scope="col" class="text-center bold"><b>this.</b></th>
            <th scope="col" class="text-center bold"><b>Model</b></th>
            <th scope="col" class="text-center bold"><b>Starships Class</b></th>
            <th scope="col" class="text-center bold"><b>Manufacturer</b></th>
            <th scope="col" class="text-center bold"><b>Cost in Credit</b></th>
            <th scope="col" class="text-center bold"><b>Length</b></th>
            <th scope="col" class="text-center bold"><b>Crew</b></th>
            <th scope="col" class="text-center bold"><b>Passengger</b></th>
            <th scope="col" class="text-center bold"><b>Max Atmosphering</b></th>
            <th scope="col" class="text-center bold"><b>Hyperdrive</b></th>
            <th scope="col" class="text-center bold"><b>Megalight</b></th>
            <th scope="col" class="text-center bold"><b>Cargo Capacity</b></th>
            <th scope="col" class="text-center bold"><b>Consumables</b></th>
            <th scope="col" class="text-center bold"><b>Films</b></th>
            <th scope="col" class="text-center bold"><b>Pilots</b></th>
            <th scope="col" class="text-center bold"><b>URL</b></th>
            <th scope="col" class="text-center bold"><b>Created</b></th>
            <th scope="col" class="text-center bold"><b>Edited</b></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="(item, index) in getList" :key="index" @click="view(item.url)" class="pointer text-center" v-infinite-scroll="loadMore" infinite-scroll-disabled="busy" infinite-scroll-distance="10">
            <th scope="row">{{ pagingNumber(index + 1) }}</th>
            <td>{{ item.name }}</td>
            <td>{{ item.model }}</td>
            <td>{{ item.starship_class }}</td>
            <td>{{ item.manufacturer }}</td>
            <td>{{ item.cost_in_credits }}</td>
            <td>{{ item.length }}</td>
            <td>{{ item.crew }}</td>
            <td>{{ item.passengers }}</td>
            <td>{{ item.max_atmosphering_speed }}</td>
            <td>{{ item.hyperdrive_rating }}</td>
            <td>{{ item.MGLT }}</td>
            <td>{{ item.cargo_capacity }}</td>
            <td>{{ item.consumables }}</td>
            <td>{{ item.films }}</td>
            <td>{{ item.pilots }}</td>
            <td>{{ item.url }}</td>
            <td>{{ item.created }}</td>
            <td>{{ item.edited }}</td>
          </tr>
        </tbody>
      </table>
    </div>
    <template>
      <div class="Aligner" style="display:none;">
        <b-modal ref="my-modal" hide-footer>
          <div class="d-block">
            <h5 class="mb-4">Detail</h5>
            <div class="d-flex mb-2">
              <div class="col-xl-5 col-sm-6">
                <div>Name :</div>
                <div>Model :</div>
                <div>Starships_Class :</div>
                <div>Manufacturer :</div>
                <div>Cost_in_Credit :</div>
                <div>Length :</div>
                <div>Crew :</div>
                <div>Passengger :</div>
                <div>Max_Atmosphering :</div>
                <div>Hyperdrive :</div>
                <div>Megalight :</div>
                <div>Cargo_Capacity :</div>
                <div>Consumables :</div>
                <div>URL :</div>
                <div>Created :</div>
                <div>Edited :</div>
              </div>
              <div class="col-xl-7 col-sm-6">
                <div>{{ Name }}</div>
                <div>{{ Model }}</div>
                <div>{{ Starships_Class }}</div>
                <div>{{ Manufacturer }}</div>
                <div>{{ Cost_in_Credit }}</div>
                <div>{{ Length }}</div>
                <div>{{ Crew }}</div>
                <div>{{ Passengger }}</div>
                <div>{{ Max_Atmosphering }}</div>
                <div>{{ Hyperdrive }}</div>
                <div>{{ Megalight }}</div>
                <div>{{ Cargo_Capacity }}</div>
                <div>{{ Consumables }}</div>
                <div>{{ URL }}</div>
                <div>{{ Created }}</div>
                <div>{{ Edited }}</div>
              </div>
            </div>
            <div class="d-flex mb-2">
              <div class="col-xl-5 col-sm-6">Films :</div>
              <div class="col-xl-7 col-sm-6">{{ Films }}</div>
            </div>
            <div class="d-flex">
              <div class="col-xl-5 col-sm-6">Pilots :</div>
              <div class="col-xl-7 col-sm-6">{{ Pilots }}</div>
            </div>
          </div>
        </b-modal>
      </div>
    </template>
  </div>
</template>

<script>
export default {
  name: 'Dashboard',
  data () {
    return {
      getList: [],
      keyword: '',
      paramkeyword: '',
      showModal: false,
      detail: '',
      busy: false,
      data: [],
      Name: '',
      Model: '',
      Starships_Class: '',
      Manufacturer: '',
      Cost_in_Credit: '',
      Length: '',
      Crew: '',
      Passengger: '',
      Max_Atmosphering: '',
      Hyperdrive: '',
      Megalight: '',
      Cargo_Capacity: '',
      Consumables: '',
      Films: '',
      Pilots: '',
      URL: '',
      Created: '',
      Edited: ''
    }
  },
  watch: {
    keyword (keyword) {
      this.paramkeyword = keyword
      let lengthVar = keyword.length
      setTimeout(() => {
        if (lengthVar !== this.paramkeyword.length) {
          return false
        } else {
          this.getPageData('https://swapi.dev/api/starships/')
        }
      }, 1000)
    }
  },
  mounted () {
    this.dataget()
  },
  methods: {
    dataget () {
      this.getPageData('https://swapi.dev/api/starships/')
    },
    getPageData (url) {
      let filter = this.getFilter()
      this.axios.get(url + filter, {
        headers: {
          accept: 'application/json',
          'Content-Type': 'multipart/form-data, text/plain'
        }
      })
        .then(response => {
          let res = response.data.results
          this.getList = res
        })
    },
    getFilter () {
      let query = '?'
      query += 'search=' + this.paramkeyword + '&'
      return query
    },
    pagingNumber (index) {
      return index + 0
    },
    view (value) {
      this.detail = value
      this.$refs['my-modal'].show()
      this.axios.get(value, {
        headers: {
          accept: 'application/json',
          'Content-Type': 'multipart/form-data, text/plain'
        }
      })
        .then(response => {
          let res = response.data
          this.Name = res.name
          this.Model = res.model
          this.Starships_Class = res.starship_class
          this.Manufacturer = res.manufacturer
          this.Cost_in_Credit = res.cost_in_credits
          this.Length = res.length
          this.Crew = res.crew
          this.Passengger = res.passengers
          this.Max_Atmosphering = res.max_atmosphering_speed
          this.Hyperdrive = res.hyperdrive_rating
          this.Megalight = res.MGLT
          this.Cargo_Capacity = res.cargo_capacity
          this.Consumables = res.consumables
          this.Films = res.films
          this.Pilots = res.pilots
          this.URL = res.url
          this.Created = res.created
          this.Edited = res.edited
        })
    },
    loadMore () {
      var count = 0
      this.busy = true

      setTimeout(() => {
        for (var i = 0, j = 10; i < j; i++) {
          this.data.push({ name: count++ })
        }
        this.busy = false
      }, 1000)
    }
  }
}
</script>

<style lang="scss">
.pointer {
  cursor: pointer;
}
.pointer:hover {
  background-color: #fff;
  color: #fff !important;
}
</style>
